#include <windows.h>

#include "uuid.h"
#include "coclsmap.h"
#include "regtable.h"
#include "Test2_h.h"
#include "UserSteps.h"

/**************************************************************************
NAME         : REGISTER_STEPCLASS
TYP          : Makro (spezifisch fr BuildRSLogix5000)
AUFGABE      : Definition von Tabelleneintrgen fr BuildRSLogix5000 zur bertragung in die Systemregistrierung
IN           : ClassName ... Name des zu registrierenden Anwenderschrittes
**************************************************************************/
#define REGISTER_STEPCLASS(ClassName) \
			{ "CLSID\\{"STR_CLSID_##ClassName"}", 0, #ClassName }, \
			{ "CLSID\\{"STR_CLSID_##ClassName"}\\InprocServer32", 0, g_szFileName }, \
			{ "CLSID\\{"STR_CLSID_##ClassName"}\\ProgID", 0, "BuildRSLogix5000."#ClassName }, \
			{ "Test2."#ClassName, 0, #ClassName }, \
			{ "Test2."#ClassName"\\CLSID", 0, "{"STR_CLSID_##ClassName"}" }, \

/**************************************************************************
NAME         : MAP_STEPCLASS
TYP          : Makro (spezifisch fr BuildRSLogix5000)
AUFGABE      : Integration von statischen COM-Klassen und ihrer CLSIDs in DllGetClassObject
IN           : ClassName ... Name des einzutragenden Anwenderschrittes
**************************************************************************/
#define MAP_STEPCLASS(ClassName) \
	static const C##ClassName##Class ClassName; \
		if (IsEqualGUID(rclsid,CLSID_##ClassName)) return (const_cast<IClassFactory*>((const IClassFactory*)&ClassName))->QueryInterface(riid, ppv); \

char g_szFileName[MAX_PATH];

/**************************************************************************
Abschnitt mit Makrodefinitionen der Registryeintrge
**************************************************************************/
BEGIN_REGISTRY_TABLE()
REGISTER_STEPCLASS(TestStep)
END_REGISTRY_TABLE()

/**************************************************************************
Abschnitt mit der Makrodefinition von DllGetClassObject
**************************************************************************/
BEGIN_IMPLEMENT_GETCLASSOBJECT()
MAP_STEPCLASS(TestStep)
END_IMPLEMENT_GETCLASSOBJECT()

/**************************************************************************
Abschnitt mit Makrodefinitionen von DllRegisterServer/DllUnregisterServer
**************************************************************************/
IMPLEMENT_REGISTERSERVER()
IMPLEMENT_UNREGISTERSERVER()

/**************************************************************************
Abschnitt mit der Makrodefinition von DllCanUnloadNow
**************************************************************************/
IMPLEMENT_CANUNLOADNOW()


/**************************************************************************
NAME         : DllMain
TYP          : DLL-Hauptroutine
AUFGABE      : Initialisierung/Bereinigung der DLL beim Einladen in den/Entfernen aus dem Speicher
IN           : hinstDLL    ... Handle zum DLL-Modul
               fdwReason   ... Grund des Aufrufs von DllMain (Einladen/Entfernen)
							 lpvReserved ... reserviert
RETVAL       : Erfolgsstatus des Aufrufs
**************************************************************************/
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason==DLL_PROCESS_ATTACH)
	{
#ifdef _DEBUG
		//MessageBoxA(NULL,"START",NULL,0);
#endif
		GetModuleFileNameA(hinstDLL,g_szFileName,MAX_PATH);
	}
	if (fdwReason==DLL_PROCESS_DETACH)
	{
		//g_lgxApp().Close();
#ifdef _DEBUG
		//MessageBoxA(NULL,"ENDE",NULL,0);
#endif
	}
	return TRUE;
}