#ifndef __USERSTEPS_H__
#define __USERSTEPS_H__

#include <windows.h>

#include "uuid.h"
#include "itfmap.h"
#include "coclsmap.h"
#include "Test2_h.h"

//Makrodefinition der IID von ICustomAction
#define IID_ICustomAction __uuidof(ICustomAction)

/**************************************************************************
NAME         : ICustomAction
TYP          : Interface
AUFGABE      : stellt Schnittstelle zu Visual Build bereit
               siehe Dokumentation von Visual Build
**************************************************************************/
struct __declspec(uuid(STR_IID_ICustomAction))
ICustomAction : IUnknown
{
      virtual HRESULT __stdcall BuildStep(
        /*[in]*/ struct IBuilder * Builder,
        /*[in]*/ struct IStep * step,
        /*[out,retval]*/ enum StepStatusEnum * ret ) = 0;
};

/**************************************************************************
NAME         : DECLARE_STEPCLASS
TYP          : Makro (spezifisch fr BuildRSLogix5000)
AUFGABE      : Deklaration von statischen und dynamischen COM-Klassen
IN           : ClassName ... Name des zu deklarierenden Anwenderschrittes
**************************************************************************/
#define DECLARE_STEPCLASS(ClassName) \
	class C##ClassName : public ICustomAction \
	{ \
	public: \
		IMPLEMENT_UNKNOWN() \
		RELEASE_DYNAMIC() \
		\
		BEGIN_INTERFACE_MAP(C##ClassName) \
		IMPLEMENTS_INTERFACE(ICustomAction) \
		END_INTERFACE_MAP() \
		\
		virtual STDMETHODIMP BuildStep(struct IBuilder *Builder, struct IStep *step, enum StepStatusEnum *ret); \
	}; \
	\
	class C##ClassName##Class : public IClassFactory \
	{ \
	public: \
		IMPLEMENT_UNKNOWN() \
		RELEASE_STATIC() \
		\
		IMPLEMENT_ICLASSFACTORY(C##ClassName) \
		\
		BEGIN_INTERFACE_MAP(C##ClassName##Class) \
		IMPLEMENTS_INTERFACE(IClassFactory) \
		END_INTERFACE_MAP() \
	}; \

/**************************************************************************
Abschnitt mit Makrodeklarationen der Anwenderschritte
**************************************************************************/
DECLARE_STEPCLASS(TestStep)

#endif